<template>
  <div class="dashboard-editor-container">
    <el-card shadow="never">
      <div id="tableau" />
    </el-card>
  </div>
</template>

<script>
export default {
  name: 'Tableau',
  props: {
    url: {
      type: String,
      default: ''
    },
    options: {
      type: Object,
      default: () => {}
    },
    width: {
      type: Number,
      default: 1000
    },
    height: {
      type: Number,
      default: 1000
    },
    filters: {
      type: Object,
      default: () => {}
    },
    apiUrl: {
      type: String,
      default: 'https://public.tableau.com/javascripts/api/tableau-2.2.2.min.js'
    }
  },
  data() {
    return {
      viz: {},
      workBook: {}
    }
  },
  computed: {
    worksheet() {
      return this.workBook.getActiveSheet()
    }
  },
  watch: {
    url() {
      if (this.viz) {
        delete this.viz
      }
      this.initViz()
    },
    height(val) {
      this.viz.setFrameSize(parseInt(this.width), parseInt(val))
    },
    width(val) {
      this.viz.setFrameSize(parseInt(val), parseInt(this.height))
    },
    filters() {
      if (this.viz) {
        delete this.viz
      }
      this.initViz()
    }
  },
  mounted() {
    const recaptchaScript = document.createElement('script')
    recaptchaScript.setAttribute('src', this.apiUrl)
    this.tableauScript = document.head.appendChild(recaptchaScript)
    window.addEventListener('load', () => {
      this.initViz()
    })
  },
  beforeDestroy() {
    delete this.viz
  },
  methods: {
    initViz() {
      const containerDiv = document.getElementById('tableau')

      // Setting up constructor options
      let options = {}
      if (!this.options) {
        options = {
          height: this.height ? this.height : 1000,
          width: this.width ? this.width : 1000,
          hideTabs: true,
          hideToolbar: true,
          onFirstInteractive: () => { this.workBook = this.viz.getWorkbook() }
        }
        if (this.filters) {
          Object.keys(this.filters).map((el) => {
            options[el.toString()] = this.filters[el.toString()]
          })
        }
      } else {
        options = this.options
      }
      this.viz = new window.tableau.Viz(containerDiv, this.url, options)
    }
  }
}
</script>

<style lang="scss" scoped>
  .dashboard-editor-container {
    padding: 32px;
    background-color: #fff;
    position: relative;
  }
</style>
